Subject: Re: [PATCH v2 1/4] Defer skb allocation -- add destroy buffers function for virtio

From: "Michael S. Tsirkin" <[email-masked]>
Date: Mon, 14 Dec 2009 22:22:53 +0200

On Mon, Dec 14, 2009 at 12:08:05PM -0800, Shirley Ma wrote:
> Hello Michael,
> 
> I agree with the comments (will have two patches instead of 4 based on
> Rusty's comments) except below one.
> 
> On Sun, 2009-12-13 at 12:26 +0200, Michael S. Tsirkin wrote:
> > That said - do we have to use a callback?
> > I think destroy_buf which returns data pointer,
> > and which we call repeatedly until we get NULL
> > or error, would be an a better, more flexible API.
> > This is not critical though.
> 
> The reason to use this is because in virtio_net remove, it has
> BUG_ON(vi->num != 0), which will be consistent with small skb packet. If
> we use NULL, error then we lose the track for vi->num, since we don't
> know how many buffers have been passed to ULPs or still unused.
> 
> Thanks
> Shirley

I dont insist, but my idea was

for (;;) {
	b = vq->destroy(vq);
	if (!b)
		break;
	--vi->num;
	put_page(b);
}

so we do not have to lose track of the counter.

-- 
MST